package routers

import (
	"github.com/gin-gonic/gin"
	"hongze/fms_api/controller/census"
	"hongze/fms_api/middleware"
)

func InitCensus(rg *gin.RouterGroup) {
	// 商品到款统计
	inv := new(census.InvoicePaymentController)
	invGroup := rg.Group("invoice_payment/").Use(middleware.Token())
	invGroup.GET("list", inv.List)

	// 销售
	sel := new(census.SellerController)
	selGroup := rg.Group("seller/").Use(middleware.Token())
	selGroup.GET("group_invoice_list", sel.GroupInvoiceList)
	selGroup.GET("invoice_list", sel.InvoiceList)
}
