package routers

import (
	"github.com/gin-gonic/gin"
	"hongze/fms_api/controller/crm"
	"hongze/fms_api/middleware"
)

func InitCrm(rg *gin.RouterGroup) {
	// 合同
	ct := new(crm.ContractController)
	crGroup := rg.Group("contract/").Use(middleware.Token())
	crGroup.GET("search_list", ct.SearchList)
	crGroup.GET("permission_list", ct.PermissionList)
	crGroup.GET("service_detail", ct.ServiceDetail)

	// 销售
	sl := new(crm.CompanySellerController)
	slGroup := rg.Group("company_seller/").Use(middleware.Token())
	slGroup.GET("list", sl.List)
	slGroup.GET("group_list", sl.GroupList)
	slGroup.GET("all_list", sl.AllList)
}
